#pragma once

#include "TaskDialog.h"

class CommonButtonsDialog : public Kerr::TaskDialog
{
public:

    CommonButtonsDialog()
    {
        SetWindowTitle(L"Common Buttons Sample");

        m_config.dwFlags |= TDF_ALLOW_DIALOG_CANCELLATION;

        m_config.dwCommonButtons = TDCBF_OK_BUTTON |
                                   TDCBF_YES_BUTTON |
                                   TDCBF_NO_BUTTON |
                                   TDCBF_CANCEL_BUTTON |
                                   TDCBF_RETRY_BUTTON |
                                   TDCBF_CLOSE_BUTTON;
    }

private:

    virtual void OnButtonClicked(int buttonId, bool& closeDialog)
    {
        switch (buttonId)
        {
            case IDOK:
            {
                SetMainInstruction(L"OK clicked");
                break;
            }
            case IDYES:
            {
                SetMainInstruction(L"Yes clicked");
                break;
            }
            case IDNO:
            {
                SetMainInstruction(L"No clicked");
                break;
            }
            case IDRETRY:
            {
                SetMainInstruction(L"Retry clicked");
                break;
            }
            case IDCLOSE:
            {
                SetMainInstruction(L"Close clicked");
                break;
            }
            case IDCANCEL:
            {
                closeDialog = true;
                break;
            }
            default:
            {
                ASSERT(false);
            }
        }
    }
};
