#pragma once

#include "TaskDialog.h"

class CounterDialog : public Kerr::TaskDialog
{
public:

    CounterDialog() :
        m_counter(0)
    {
        SetWindowTitle(L"Counter Sample");

        AddButton(L"Increment", Button_Increment);
        AddButton(L"Decrement", Button_Decrement);

        m_config.dwFlags |= TDF_ALLOW_DIALOG_CANCELLATION;
    }

private:

    enum
    {
        Button_Increment = 101,
        Button_Decrement
    };

    void UpdateMessage()
    {
        CString text;
        text.Format(L"%d", m_counter);

        SetMainInstruction(text.GetString());
    }

    virtual void OnDialogConstructed()
    {
        UpdateMessage();
    }

    virtual void OnButtonClicked(int buttonId, bool& closeDialog)
    {
        switch (buttonId)
        {
            case Button_Increment:
            {
                ++m_counter;
                UpdateMessage();
                break;
            }
            case Button_Decrement:
            {
                --m_counter;
                UpdateMessage();
                break;
            }
            case IDCANCEL:
            {
                closeDialog = true;
                break;
            }
            default:
            {
                ASSERT(false);
            }
        }
    }

    int m_counter;
};
