#pragma once

#include "TaskDialog.h"

class EnableDisableDialog : public Kerr::TaskDialog
{
public:

    EnableDisableDialog()
    {
        SetWindowTitle(L"Enable/Disable Sample");

        AddRadioButton(L"Radio button", Button_RadioButton);
        AddButton(L"Enable", Button_Enable);
        AddButton(L"Disable", Button_Disable);

        m_config.dwFlags |= TDF_ALLOW_DIALOG_CANCELLATION;
    }

private:

    enum
    {
        Button_RadioButton = 101,
        Button_Enable,
        Button_Disable
    };

    virtual void OnDialogConstructed()
    {
        EnableButton(Button_Enable, false);
    }

    virtual void OnButtonClicked(int buttonId, bool& closeDialog)
    {
        switch (buttonId)
        {
            case Button_Enable:
            {
                EnableRadioButton(Button_RadioButton);
                EnableButton(Button_Enable, false);
                EnableButton(Button_Disable);

                break;
            }
            case Button_Disable:
            {
                EnableRadioButton(Button_RadioButton, false);
                EnableButton(Button_Enable);
                EnableButton(Button_Disable, false);

                break;
            }
            case IDCANCEL:
            {
                closeDialog = true;
                break;
            }
            default:
            {
                ASSERT(false);
            }
        }
    }
};