#pragma once

#include "TaskDialog.h"
#include "resource.h"

class IconsDialog : public Kerr::TaskDialog
{
public:

    IconsDialog()
    {
        SetWindowTitle(L"Icons Sample");
        SetMainInstruction(L"Main Instruction");
        SetFooter(L"Footer");

        AddRadioButton(L"None", Button_None);
        AddRadioButton(L"Warning", Button_Warning);
        AddRadioButton(L"Information", Button_Information);
        AddRadioButton(L"Error", Button_Error);
        AddRadioButton(L"Shield", Button_Shield);
        AddRadioButton(L"Custom", Button_Custom);

        m_config.dwFlags |= TDF_ALLOW_DIALOG_CANCELLATION;
    }

private:

    enum
    {
        Button_None = 101,
        Button_Warning,
        Button_Error,
        Button_Information,
        Button_Shield,
        Button_Custom
    };

    virtual void OnButtonClicked(int /*buttonId*/, bool& closeDialog)
    {
        closeDialog = true;
    }

    virtual void OnRadioButtonClicked(int buttonId)
    {
        switch (buttonId)
        {
            case Button_None:
            {
                SetMainIcon(static_cast<PCWSTR>(0));
                SetFooterIcon(static_cast<PCWSTR>(0));
                break;
            }
            case Button_Warning:
            {
                SetMainIcon(TD_WARNING_ICON);
                SetFooterIcon(TD_WARNING_ICON);
                break;
            }
            case Button_Information:
            {
                SetMainIcon(TD_INFORMATION_ICON);
                SetFooterIcon(TD_INFORMATION_ICON);
                break;
            }
            case Button_Error:
            {
                SetMainIcon(TD_ERROR_ICON);
                SetFooterIcon(TD_ERROR_ICON);
                break;
            }
            case Button_Shield:
            {
                SetMainIcon(TD_SHIELD_ICON);
                SetFooterIcon(TD_SHIELD_ICON);
                break;
            }
            case Button_Custom:
            {
                SetMainIcon(IDI_MSN);
                SetFooterIcon(IDI_MSN);
                break;
            }
            default:
            {
                ASSERT(false);
            }
        }
    }

};
