#pragma once

#include "TaskDialog.h"

class ProgressDialog : public Kerr::TaskDialog
{
public:

    ProgressDialog()
    {
        SetWindowTitle(L"Progress Sample");

        m_config.dwFlags |= TDF_SHOW_PROGRESS_BAR | 
                            TDF_CALLBACK_TIMER |
                            TDF_ALLOW_DIALOG_CANCELLATION;
    }

private:

    enum
    {
        MaxRange = 5000
    };

    virtual void OnDialogConstructed()
    {
        SetProgressBarRange(0, MaxRange);
    }

    virtual void OnButtonClicked(int /*buttonId*/, bool& closeDialog)
    {
        closeDialog = true;
    }

    virtual void OnTimer(DWORD milliseconds, bool& reset)
    {
        if (MaxRange >= milliseconds)
        {
            CString text;
            text.Format(L"%.f%%", static_cast<double>(milliseconds) / MaxRange * 100);
            SetMainInstruction(text.GetString());

            SetProgressBarPosition(milliseconds);
        }
        else
        {
            reset = true;
        }
    }

};
