#pragma once

#include "TaskDialog.h"

class TimerDialog : public Kerr::TaskDialog
{
public:

    TimerDialog() :
        m_reset(false)
    {
        SetWindowTitle(L"Timer Sample");
        SetMainInstruction(L"Time elapsed: 0 seconds");
        AddButton(L"Reset", Button_Reset);

        m_config.dwFlags |= TDF_ALLOW_DIALOG_CANCELLATION | 
                            TDF_CALLBACK_TIMER;
    }

private:

    enum
    {
        Button_Reset = 101
    };

    virtual void OnTimer(DWORD milliseconds, 
                         bool& reset)
    {
        CString text;

        text.Format(L"Time elapsed: %.2f seconds", 
                    static_cast<double>(milliseconds) / 1000);

        SetMainInstruction(text.GetString());

        reset = m_reset;
        m_reset = false;
    }

    virtual void OnButtonClicked(int buttonId, 
                                 bool& closeDialog)
    {
        switch (buttonId)
        {
            case Button_Reset:
            {
                m_reset = true;
                break;
            }
            case IDCANCEL:
            {
                closeDialog = true;
                break;
            }
            default:
            {
                ASSERT(false);
            }
        }
    }

    bool m_reset;
};
