#pragma once

#include "TaskDialog.h"

class UpdateTextDialog : public Kerr::TaskDialog
{
public:

    UpdateTextDialog()
    {
        SetWindowTitle(L"Window title");
        SetMainInstruction(L"Main instruction");
        SetContent(L"Content");
        SetFooter(L"Footer");
        SetExpandedInformation(L"Expanded information");

        AddButton(L"Update window title", Button_UpdateWindowTitle);
        AddButton(L"Update main instruction", Button_UpdateMainInstruction);
        AddButton(L"Update content", Button_UpdateContent);
        AddButton(L"Update footer", Button_UpdateFooter);
        AddButton(L"Update expanded information", Button_UpdateExpandedInformation);

        m_config.dwFlags |= TDF_ALLOW_DIALOG_CANCELLATION;
    }

private:

    enum
    {
        Button_UpdateWindowTitle = 101,
        Button_UpdateMainInstruction,
        Button_UpdateContent,
        Button_UpdateFooter,
        Button_UpdateExpandedInformation
    };

    virtual void OnButtonClicked(int buttonId, bool& closeDialog)
    {
        switch (buttonId)
        {
            case Button_UpdateWindowTitle:
            {
                SetWindowTitle(L"Window title (updated)");
                break;
            }
            case Button_UpdateMainInstruction:
            {
                SetMainInstruction(L"Main instruction (updated)");
                break;
            }
            case Button_UpdateContent:
            {
                SetContent(L"Content (updated)");
                break;
            }
            case Button_UpdateFooter:
            {
                SetFooter(L"Footer (updated)");
                break;
            }
            case Button_UpdateExpandedInformation:
            {
                SetExpandedInformation(L"Expanded information (updated)");
                break;
            }
            case IDCANCEL:
            {
                closeDialog = true;
                break;
            }
            default:
            {
                ASSERT(false);
            }
        }
    }
};
